########################################################################
## Vladimir Canudas-Roma
## Demography 214
## Sample program for reading data from HMD and constructing
## graphs of cohort and period Life expectancy and Lexis surfaces
########################################################################


###Plot PERIOD Life Expectancy By Sex

## download and save to current working directory the
##    Life expectancy at birth
##    By year of death (period)
## rename it it SWE_E0per.txt
## 

A<-read.table("SWE_E0per.txt",header=TRUE,fill=TRUE,skip=2,as.is=T)



x11()
#par(mfrow=c(2,1))

plot(range(A$Year),range(A$Male,A$Female),type='n',xlab='Year',
     ylab='')
title("Female, male and total period life expectancy.") 
lines(A$Year,A$Female,col='red',lty=1) 
lines(A$Year,A$Male,col='blue',lty=1)


plot(range(A$Year),range(A$Female-A$Male),type='n',xlab='Year',
     ylab='')
title("Female-Male mortality gap in the period LE.") 
lines(A$Year,(A$Female-A$Male),col='red',lty=1) 



###Plot COHORT  Life Expectancy By Sex

## Download Swedish Cohort Life Expectancy data into current directory
## and rename it SWE_E0coh.txt_

B<-read.table("SWE_E0coh.txt",header=TRUE,fill=TRUE,skip=2,as.is=T)




x11()
#par(mfrow=c(2,1))

plot(range(B$Year),range(B$Male,B$Female),type='n',xlab='Year',
     ylab='')
title("Female, male and total cohort life expectancy.") 
lines(B$Year,B$Female,col='red',lty=1) 
lines(B$Year,B$Male,col='blue',lty=1)


plot(range(B$Year),range(B$Female-B$Male),type='n',xlab='Year',
     ylab='')

title("Female-Male mortality gap in the period LE.") 
lines(B$Year,(B$Female-B$Male),col='red',lty=1) 






### All on the same axes

x11()
#par(mfrow=c(2,1))

plot(range(A$Year,B$Year),range(A$Male,A$Female,B$Male,B$Female),
     type='n',ylab='',xlab='Year')
title("Female, male and total period life expectancy.") 
lines(A$Year,A$Female,col='red',lty=1) 
lines(A$Year,A$Male,col='blue',lty=1)
lines(B$Year,B$Female,col='red',lty=4) 
lines(B$Year,B$Male,col='blue',lty=4)


#LifeExpectancyGap<-c(min(female-male),max(female-male))
#plot(Year,LifeExpectancyGap,col='white')

plot(range(A$Year,B$Year),range((A$Female-A$Male),(B$Female-B$Male)),
     type='n',ylab='',xlab='Year')

title("Female-male mortality gap in the period and cohort LE.") 
lines(A$Year,(A$Female-A$Male),col='red',lty=1) 
lines(B$Year,(B$Female-B$Male),col='blue',lty=1) 

## Draw some spectacular pictures of death rates

########################################################################
## Now read death rates for lexis surfaces
## the file will download as Mx_1x1.txt" prepend SWE for
## tidiness
########################################################################

## download Swedish 

C<-read.table("SWE_Mx_1x1.txt",header=TRUE,fill=TRUE,
              as.is=T,skip=2,na.strings='.')
yearC<-matrix(C$Year,111)
maleC<-matrix(C$Male,111)
femaleC<-matrix(C$Female,111)


Age<-c(0:110)
Year<-yearC[1,]

#contour(Year,Age,t(maleC),xlab="",ylab="",levels=seq(0,1,.005))
contour(Year,Age,t(maleC),xlab="",ylab="",levels=seq(0,1,.05))

image(Year,Age,t(maleC),zlim=c(0,1),col='white')
image(Year,Age,t(maleC),zlim=range(c(0,.5)),col='green',add=T)
image(Year,Age,t(maleC),zlim=range(c(0,.1)),col='red',add=T)
image(Year,Age,t(maleC),zlim=range(c(0,.005)),col='yellow',add=T)
image(Year,Age,t(maleC),zlim=range(c(0,.001)),col='blue',add=T)

filled.contour(Year,Age,t(maleC),levels=c(0,.0001,.0005,.001,.005,.01,.05,6),ylab="Age",xlab="Year")
title("Lexis Surface for Swedish deaths rates")

filled.contour(Year,Age,t(maleC),levels=c(0,.0001,.0005,.001,.005,.01,.05,6),col=c('red','blue','green','yellow','grey','purple','orange'),ylab="Age",xlab="Year")
title("Lexis Surface for Swedish deaths rates")
